/*-------------------------------------------------------------------------+
| Copyright 2019 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.common.ui.javafx.layout;

import javafx.fxml.FXML;
import javafx.scene.Node;

/**
 * Generic interface for JavaFX controllers which can be hierarchically composed.
 * 
 * @author munaro
 */
public interface ICompositeFXController {

	/**
	 * Returns a JavaFX {@link Node} with the layout specified in the {@link FXML} resource and
	 * associated with a controller of type {@code T}.
	 */
	public Node getLayout();

	/** Returns the location of the {@link FXML} resource with the view's layout. */
	public String getFXMLLocation();

	/** Adds the {@link ICompositeFXController}s to the container. */
	public void addContainments(ICompositeFXController[] containments);
}
